#!/usr/local/bin/perl
use locale;

print "Enter the number of words that each text segment should have:\n ";
  $base = <STDIN>;
chomp $base;

print "Enter the path where the text files are:\nRemember to put double slashes (\\\\) or backslash (/)\n";
$dir = <STDIN>;
chomp $dir;
opendir(BIN, $dir) or die "Can't open $dir: $!";

while(defined ($file = readdir BIN)) {
			  next if $file =~ /^\.\.?$/;
			  next if $file =~ /pl$/;
			  next if $file =~ /[T|R]esults\.txt/;
                          next if $file =~ /^N\_.*?\.txt/;
  			  open (FILE, "$file");
                          
                          
                          while (<FILE>) {
						    $text .= $_;   #reads the text and stores it in a variable
                          }
                          $_ = $text;
							 # We tokenize the text using the following regexes
                          
                            
			s/\s+/\n/g;                     # put every word on a different line
                          s/^\n//;                        # remove possible initial empty line
                          s/([.,!?:;,])\n*?/\n$1\n/g;       # put punctuation signs on separate line
                          s/\n(["'`])([^\n])/\n$1\n$2/g;  # put initial quote on separate line
                          s/([^\n])(["'`])\n/$1\n$2\n/g;  # put final quote on separate line
                          s/([^\n])([.,])\n/$1\n$2\n/g;   # put punctuation before " on separate line
                          s/\n([A-Z])\n\./\n$1./g;          # take care of initials in names
                          # print $_;
                          ##s/\n\.\n([^\"A-Z])/\.\n$1/g;      # put periods behind abbreviations
                          s/(\.[A-Z]+)\n\.\n/$1.\n/g;       # put periods behind abbreviations
                          s/([^\n])\'s\n/$1\n\'s\n/g;       # move final 's to separate line
                          s/([^\n])n\'t\n/$1\nn\'t\n/g;     # move final n't to separate line
                          s/([^\n])\'re\n/$1\n\'re\n/g;     # move final 're to separate line
                          # print $_;
                          s/\n\$([^\n])/\n\$\n$1/g;         # move initial $ to separate line
                          s/([^\n])%\n/$1\n%\n/g;           # move final % to separate line
                          s/Mr\n\.\n/Mr.\n/g;               # frequent abbreviation error    
                          s/\n\.\n/.\n/g;	    # as above but in Greek k.
                          s/\n+/\n/g;		  #removes blank lines
                          s/^\s*//;		    # removes lines with spaces
                          
                          @words = ();
                          @words = split(/\n/, $_); # Splits the text string using \n as seperators

                          $i = 0;
                          $initwordcount = 0;
                          
                          foreach (@words) {                                  # This loop counts only the words and ignores the punctuation
                                                    if ($_ =~ /\w+/) {
                                                    $initwordcount++;                          
                                                    }
                          }
                          if ($initwordcount < $base) {                       # Checks whether the $base is greater than the textsize. If this happens prints in "ErrorLog.txt" witch files have less words than the base.  
                                                    open (LOG, ">>ErrorLog.txt");
                                                    print (LOG "$file\n");
                          }
                          else {
                                                    foreach (@words) {
                                                                              push (@narray, $_);       # For each token in the array (punctuation and words) we create a new array (@narray)
                                                                             
                                                                              if ($_ =~ /\w+/) {	
                                                                              $wordcount++;             # We advance counter $wordcount if the loop meets a word (defined as \w+)
                                                                             
                                                                                                        
                                                                                                        if ($wordcount == $base) {
                                                                                                                                  open (OUTFILE, ">N\_$file\_$i.txt ");             # If the counter reaches the desired value (defined by the user in $base) we open a new file with prefix N_ infix the original filename and suffix an index i which starts from 0
                                                                                                                                  print OUTFILE ("@narray");                          # We print the contents of @narray which contain the exact number of words defined by the user and the punctuation.
                                                                                                                                  close OUTFILE;
                                                                                                                                  $i++;                     # We advance the counter by one so that next file split has greater index that the previous.
                                                                                                                                  $wordcount = 0;           # We initialize the wordcount in order to count again from 0 to $base
                                                                                                                                  @narray = ();             # We initialize @narray in order to take next n words (defined by the $base) form the loop
                                                                                                        }
                                                                                                       
                                                                              }
                                                    }

                          }
$text = ();
@words =();
$wordcount = 0;
@narray = ();
}
close LOG;
close OUTFILE;
closedir(BIN);